package patterns.behavioral.chainofresponsibility.client;

import patterns.behavioral.chainofresponsibility.ClickEvent;
import patterns.behavioral.chainofresponsibility.impl.Button;
import patterns.behavioral.chainofresponsibility.impl.TextField;
import patterns.behavioral.chainofresponsibility.impl.Window;

public class Client {


	public static void main(String [] args) {
		
		// compose the GUI
		Button button = new Button("OK");
		TextField textfield = new TextField();
		textfield.setEnabled(true);
		
		Window window = new Window();
		window.AddChild(button);
		window.AddChild(textfield);
		
		// simulate the click event
		ClickEvent clickEvent = new ClickEvent(100, 50);
		textfield.handleClickEvent(clickEvent);
		
		// now the text field is disabled
		textfield.setEnabled(false);
		
		// now click on the text field again
		clickEvent = new ClickEvent(120, 50);
		textfield.handleClickEvent(clickEvent);
		
	}
	
}
