package patterns.behavioral.chainofresponsibility.impl;

import patterns.behavioral.chainofresponsibility.ClickEvent;
import patterns.behavioral.chainofresponsibility.Widget;

public class TextField extends Widget {

	private boolean enabled = true;

	public boolean isEnabled() {
		return enabled;
	}

	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}

	@Override
	public void handleClickEvent(ClickEvent event) {
		if (this.enabled) {
			System.out.println ("TextField set cursor using ClickEvent. Coordinates: x="
							+ event.getX() + ", y=" + event.getY());
		}
		else
		{
			if (this.parent != null)
			{
				this.parent.handleClickEvent(event);
			}
		}

	}

}
