package patterns.behavioral.command.client;

import patterns.behavioral.command.Command;

/**
 * simulates what a custom button does
 */
public class AddUserButton {

	private Command command;
	
	public AddUserButton(Command command) {
		this.command = command;
	}
	
	/**
	 * the method that is invoked when the button is pushed
	 */
	public void buttonPushed() {
		this.command.execute();
	}
}
