package patterns.behavioral.command.client;

import patterns.behavioral.command.impl.AddUserCommand;
import patterns.behavioral.command.impl.UserManager;
import patterns.behavioral.memento.impl.CommandHistory;

public class Client {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		UserManager userManager = UserManager.getInstance();
		CommandHistory commandHistory = CommandHistory.getInstance();
		
		AddUserCommand command = new AddUserCommand();
		command.setUserManager(userManager);
		
		AddUserButton button = new AddUserButton(command);
		
		// simulates that the button is pushed 3 times
		// in reality, the function should be triggered 
		// when the button is pushed by the user

		button.buttonPushed();
		button.buttonPushed();
		button.buttonPushed();
		
	}

}
