package patterns.behavioral.command.impl;

import patterns.behavioral.command.Command;
import patterns.behavioral.iterator.client.User;
import patterns.behavioral.memento.client.UserGenerator;

public class AddUserCommand extends Command {
	
	private UserManager userManager;

	public void setUserManager(UserManager userManager) {
		this.userManager = userManager;
	}
	
	@Override
	public void execute() {
		User user = null;
		
		// TODO get user info from the user interface. Here, we use random-generated user
		user = UserGenerator.getRandomUser();
		
		// modify the model
		this.userManager.addUser(user);
	}

}
