package patterns.behavioral.command.impl;

import java.util.ArrayList;
import java.util.Iterator;

import patterns.behavioral.command.Command;

public class MacroCommand extends Command {

	private ArrayList<Command> subcommands = new ArrayList<Command>();
	
	@Override
	public void execute() {
		// iterate over the subcommands and execute each command one by one
		Iterator<Command> subcommandsItr = subcommands.iterator();
		while (subcommandsItr.hasNext()) {
			subcommandsItr.next().execute();
		}
	}
	
	/**
	 * add a new command to the macro 
	 */
	public void addCommand(Command command) {
		this.subcommands.add(command);
	}

	/**
	 * remove the command from the contained subcommands 
	 */
	public void removeCommand(Command command) {
		this.subcommands.remove(command);
	}
	
}
