package patterns.behavioral.command.impl;

import java.util.ArrayList;
import java.util.List;

import patterns.behavioral.iterator.client.User;

public class UserManager {

	private List<User> managedUsers = new ArrayList<User>();
	
	private int currentIndex;
	
	int getCurrentIndex() {
		return currentIndex;
	}

	void setCurrentIndex(int currentIndex) {
		this.currentIndex = currentIndex;
	}

	public void addUser(User user) {
		System.out.println("adding user: " + user.toString());
		
		this.managedUsers.add(user);
		this.currentIndex = this.managedUsers.size() - 1;
	}
	
	public void setUser(User user, int atIndex) {
		System.out.println("setting user: " + user.toString() + " at index: " + atIndex);

		this.managedUsers.set(atIndex, user);
		this.currentIndex = atIndex;
	}
	
	public void removeUser(int atIndex) {
		System.out.println("removing user: " + this.managedUsers.get(atIndex).toString() + " at index: " + atIndex);
		
		this.managedUsers.remove(atIndex);
		this.currentIndex = atIndex;
	}
	
	private static UserManager instantce = new UserManager();
	
	public static UserManager getInstance() {
		return instantce;
	}
	
	
}
