package patterns.behavioral.interpreter;

import java.util.HashMap;

/**
 * the context that is needed during interpretation
 */
public class Context {

	private HashMap<String, Object> variableValues = new HashMap<String, Object>();
	
	/**
	 * assign a value to the identifier
	 * @param identifier
	 * @param value
	 */
	public void assign(String identifier, Object value) {
		this.variableValues.put(identifier, value);
	}

	/**
	 * lookup the value given the identifier
	 * @param identifier
	 * @return
	 */
	public Object lookup(String identifier) {
		return this.variableValues.get(identifier);
	}
	
}
