package patterns.behavioral.interpreter.impl;

import patterns.behavioral.interpreter.Context;

public class Identifier extends TerminalExpression {

	/**
	 * name of the identifier
	 */
	private String name;
	
	public Identifier(String name) {
		this.name = name;
	}



	@Override
	public Object interpret(Context context) {
		System.out.println("interpreting " + this.toString());
		// constants evaluate to their values
		Object result = context.lookup(this.name);

		System.out.println(this.toString() + " interprets to " + result);

		
		// identifier evaluates to its value assignment in the context
		return result;
	}

	public String toString() {
		return this.name.toString();
		
	}
	
}
