package patterns.behavioral.iterator.client;

import patterns.behavioral.iterator.Iterator;
import patterns.behavioral.iterator.List;

public class PrintUsers {

	
	
	public static void testPrintUsers() {
		List list = ListFactoryMethod.getUserList();
		
		// get the iterator
		Iterator userIterator = list.createIterator();
		
		printUsers(userIterator);
		
	}

	/**
	 * the method that iterate over userIterator and print each user 
	 * @param userIterator
	 */
	public static void printUsers(Iterator userIterator) {
		// reset the cursor
		userIterator.first();
		while (! userIterator.isDone()) {
			// get current item
			User user = (User) userIterator.currentItem();
			// use the item
			System.out.println("got a user " + user.toString());
			
			userIterator.next();
		}
	}
	
	
}