package patterns.behavioral.iterator.impl;

import patterns.behavioral.iterator.Iterator;
import patterns.behavioral.iterator.List;

public class ArrayList implements List {
	
	private Object[] items;
	
	private int count = 0;


	public Iterator createIterator() {
		return new ListIterator(this);
	}

	public void add(Object item) {
		if (count == items.length) {
			// we have to expand the array:
			// 1. create a larger array
			// 2. copy the items to the new array
			// 3. replace this.items with the new array
		}
		
		this.items[ this.count ] = item;
		this.count ++;
	}
	
	
	/**
	 * create the list of using defaultCapacity
	 * 
	 * @param defaultCapacity
	 */
	public ArrayList(int defaultCapacity) {
		items = new Object[defaultCapacity];
	}

	public int getCount() {
		return this.count;
	}

	public Object get(int index) {
		if (index < 0 || index >= items.length) {
			throw new IllegalArgumentException("invalid index: " + index);
		}
		
		return items[index];
	}
}
