package patterns.behavioral.iterator.impl;

import patterns.behavioral.iterator.Iterator;


class ListIterator implements Iterator {
	
	/**
	 * the reference to the list to be iterated
	 */
	private ArrayList list;

	/**
	 * points to the object currently iterated
	 */
	private int currentPosition = 0;

	public ListIterator(ArrayList list) {
		this.list = list;
	}
	
	public Object currentItem() {
		return list.get(this.currentPosition);
	}

	public void first() {
		this.currentPosition = 0;
	}

	public boolean isDone() {
		return currentPosition == list.getCount();
	}

	public void next() {
		this.currentPosition ++;
	}

}
