package patterns.behavioral.iterator.impl;

import patterns.behavioral.iterator.Iterator;
import patterns.behavioral.iterator.List;

public class ReverseListIterator implements Iterator {

	private List list;
	
	private int currentPosition;
	
	public ReverseListIterator(List list) {
		this.list = list;
		this.currentPosition = list.getCount() - 1;
	}
	
	public Object currentItem() {
		return list.get(this.currentPosition);
	}

	public void first() {
		this.currentPosition = list.getCount() - 1;
	}

	public boolean isDone() {
		return this.currentPosition >= 0;
	}

	public void next() {
		this.currentPosition--;
	}

}
