package patterns.behavioral.mediator;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import patterns.behavioral.observer.Subject;

public abstract class Widget extends Subject {
	
	protected DialogDirector dialogDirector;
	
	public Widget(DialogDirector dialogDirector) {
		this.dialogDirector = dialogDirector;
	}
	
	public void changed() {
		// send notification about the change
		this.dialogDirector.update(this);
	}
	
	public abstract void handleMouse(MouseEvent event);

	public abstract void handleKey(KeyEvent event);
	
}
