package patterns.behavioral.mediator.impl;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import patterns.behavioral.mediator.DialogDirector;
import patterns.behavioral.mediator.Widget;

public class Button extends Widget {

	private String label;
	
	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public Button(DialogDirector dialogDirector) {
		super(dialogDirector);
	}

	@Override
	public void handleMouse(MouseEvent event) {
		// button clicked: notify listener
		this.changed();
	}

	@Override
	public void handleKey(KeyEvent event) {
		// notify listeners only if enter is pressed
		if (event.getKeyCode() == event.VK_ENTER) {
			this.changed();
		}
	}

}
