package patterns.behavioral.mediator.impl;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import patterns.behavioral.mediator.DialogDirector;
import patterns.behavioral.mediator.Widget;

public class ListBox extends Widget {

	private int selectedIndex = 0;
	
	private ArrayList<String> values;
	
	public ListBox(DialogDirector dialogDirector) {
		super(dialogDirector);
		this.values = new ArrayList<String>();
	}

	@Override
	public void handleMouse(MouseEvent event) {
		// change selected value
		// TODO: check mouse position and change selected index
		// notify listeners
		this.changed();
	}

	@Override
	public void handleKey(KeyEvent event) {
		// no response to keyboard
	}

	//-----------------------------------------------
	// list specific methods
	//-----------------------------------------------
	
	public void addValue(String value) {
		this.values.add(value);
	}
	
	public void removeValue(String value) {
		this.values.remove(value);
	}
	
	public int getSelectedIndex() {
		return this.selectedIndex;
	}
	
	public String getSelectedValue() {
		return this.values.get(this.selectedIndex);
	}
	
	
}
