package patterns.behavioral.mediator.impl;

import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import patterns.behavioral.mediator.DialogDirector;
import patterns.behavioral.mediator.Widget;
import patterns.behavioral.observer.Subject;

public class MainUIController extends DialogDirector {

	private ListBox userListBx;
	
	private Button addButton;
	
	private Button deleteButton;
	
	private TextField textField;

	private String selectedUser;
	
	@Override
	public void showDialog() {
		// TODO implement the logic to show the dialog

	}

	/**
	 * widget event listener
	 */
	public void update(Subject notifier) {
		if (notifier == this.addButton) {
			// add button pushed: get textField value and add to list
			String value = this.textField.getText();
			this.userListBx.addValue(value);
		}
		else if (notifier == this.deleteButton) {
			// remove the selected user
			this.userListBx.removeValue(this.selectedUser);
		}
		else if (notifier == this.userListBx) {
			// some user clicked: change selectedUser value
			this.selectedUser = this.userListBx.getSelectedValue();
		}
	}

	@Override
	public void createWidgets() {
		// create widgets and register this as the observer
		
		this.addButton = new Button(this);
		this.addButton.setLabel("Add User");
		
		this.deleteButton = new Button(this);
		this.deleteButton.setLabel("Delete User");
		
		this.textField = new TextField(this);
		
		this.userListBx = new ListBox(this);
	}

}
