package patterns.behavioral.mediator.impl;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import patterns.behavioral.mediator.DialogDirector;
import patterns.behavioral.mediator.Widget;

public class TextField extends Widget {

	private String text = "";
	
	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}



	public TextField(DialogDirector dialogDirector) {
		super(dialogDirector);
	}

	
	
	@Override
	public void handleMouse(MouseEvent event) {
		// mouse clicked on the text field:
		// just request focus and make the text field the selected widget
		
	}

	@Override
	public void handleKey(KeyEvent event) {
		if (event.getKeyCode() != event.VK_ENTER) {
			// update text value
			this.text = this.text + event.getKeyChar();
			
			// notify listeners
			this.changed();
		}
		
	}

}
