package patterns.behavioral.memento;

import patterns.behavioral.command.Command;

public abstract class UndoableCommand extends Command {

	protected Memento savedState;
	
	/**
	 * undo the command
	 */
	public abstract void unexecute();
	
	/**
	 * redo the undone command
	 */
	public abstract void reExecute();
	
	/**
	 * clone the command to be put in the history
	 */
	public abstract UndoableCommand clone();
}
