package patterns.behavioral.memento.client;

import patterns.behavioral.memento.impl.CommandHistory;
import patterns.behavioral.memento.impl.AddUserCommand;
import patterns.behavioral.memento.impl.UserManager;

public class Client {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		UserManager userManager = UserManager.getInstance();
		CommandHistory commandHistory = CommandHistory.getInstance();
		
		AddUserCommand command = new AddUserCommand();
		command.setUserManager(userManager);
		
		/**
		 * execute the command 3 times: add 3 users
		 */
		command.execute();
		commandHistory.addCommandToHistory(command);

		command.execute();
		commandHistory.addCommandToHistory(command);
		
		command.execute();
		commandHistory.addCommandToHistory(command);
		
		/**
		 * undo the last 2 commands
		 */
		commandHistory.undoCommand();
		commandHistory.undoCommand();
		
		/**
		 * redo one command
		 */
		commandHistory.redoCommand();
		
	}

}
