package patterns.behavioral.memento.client;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Random;

import patterns.behavioral.iterator.client.User;

/**
 * utils for getting users
 *
 */
public class UserGenerator {
	private static String [] firstNames = {
		"John", "Larry", "Joe", "Joey", "Johnathan", "Mary", "William"
	};
	
	private static String [] lastNames = {
		"Smith", "Willis", "Tompson", "Gibson", "Jones", "Clark", "Anderson"
	};
	
	private static int minAge = 15;
	
	private static int maxAge = 55;

	private static Random random = new Random(Calendar.getInstance().getTimeInMillis());;
	
	public static User getRandomUser() {
		String name = firstNames[random.nextInt(firstNames.length)] + " " + 
			lastNames[random.nextInt(lastNames.length)];
		int age = minAge + random.nextInt(maxAge - minAge);
		
		return new User(name, age);
	}
	
}
