package patterns.behavioral.observer;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public abstract class Subject {

	/**
	 * registered observers
	 */
	protected Collection observers = new ArrayList();
	
	public void attach(Observer observer) {
		// add to observers collection
		observers.add(observer);
	}
	
	public void detach(Observer observer) {
		// remove from observers collection
		observers.remove(observer);
	}
	
	public void notifyObservers() {
		// iterate over observers collection
		Iterator iterator = observers.iterator();
		while (iterator.hasNext()) {
			Observer observer = (Observer) iterator.next();
			// send notification
			observer.update(this);
		}
	}
}
