package patterns.behavioral.observer.impl;

import patterns.behavioral.observer.Observer;
import patterns.behavioral.observer.Subject;

public class MessageDialog implements Observer {

	private String name;
	
	public MessageDialog(String name) {
		super();
		this.name = name;
	}

	public void update(Subject notifier) {
		// message dialog receives notification. display the message
		
		MessageHandler handler = (MessageHandler) notifier;
		System.out.println ("[MessageDialog " + this.name+ "] " + handler.getLatestMessage());
	}

}
