package patterns.behavioral.observer.impl;

import patterns.behavioral.observer.Subject;

public class MessageHandler extends Subject {

	private String latestMessage = "";

	public String getLatestMessage() {
		return latestMessage;
	}

	public MessageHandler() {
		// use a thread to simulate message arrival
		MessageReceiver receiver = new MessageReceiver(this);
		receiver.start();
	}

	void messageReceived(String message) {
		// update the latest message and notify all registered observers
		this.latestMessage = message;
		this.notifyObservers();
	}
	
	class MessageReceiver extends Thread {
		
		private MessageHandler parent;
		
		
		
		public MessageReceiver(MessageHandler parent) {
			super();
			this.parent = parent;
		}



		@Override
		public void run() {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
			
			parent.messageReceived("You've got mail");
			
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
			}

			parent.messageReceived("Bob harvested your carrot");
			
		}

	}
}
