package patterns.behavioral.state;

public abstract class State {

	protected Context context;
	
	public State(Context context) {
		this.context = context;
	}
	
	/**
	 * handler when attacked
	 */
	public abstract void handleAttacked();
	
	/**
	 * handler when someone approaches
	 */
	public abstract void handleApproached();
	
	/**
	 * handler when someone starts conversation
	 */
	public abstract void handleConversation();
	
	/**
	 * handler when someone left
	 */
	public abstract void handleLeft();
}
