package patterns.behavioral.state.impl;

import patterns.behavioral.state.Context;
import patterns.behavioral.state.State;

public class EscapingState extends State {

	public EscapingState(Context context) {
		super(context);
	}

	@Override
	public void handleApproached() {
		boolean hostile = false;
		// check for hostility
		
		if (hostile) {
			// continue escaping
		}
		else {
			// start conversation
			this.context.setState(new InConversationState(this.context));
		}
	}

	@Override
	public void handleAttacked() {
		// continue escaping
	}

	@Override
	public void handleConversation() {
		this.context.setState(new InConversationState(this.context));
	}

	@Override
	public void handleLeft() {
		// do nothing
		
	}

}
