package patterns.behavioral.state.impl;

import patterns.behavioral.state.Context;
import patterns.behavioral.state.State;

public class InBattleState extends State {

	public InBattleState(Context context) {
		super(context);
	}

	@Override
	public void handleApproached() {
		// do nothing

	}
	
	private void handleBattle() {
		// TODO implement the battle logic
	}

	@Override
	public void handleAttacked() {
		this.handleBattle();
	}

	@Override
	public void handleConversation() {
		// enemy has something to say. should we stop the battle?
		boolean stopBattle = false;
		// TODO implement the logic to determine whether to stop
		
		if (stopBattle) {
			// let's stop the battle and hear what the enemy wants to way.
			this.stopBattle();
			this.context.setState(new InConversationState(this.context));
		}
		else {
			// we don't want to listen to the enemy
			this.handleBattle();
		}
		
	}

	private void stopBattle() {
		// TODO implement it
		
	}

	@Override
	public void handleLeft() {
		// should we chase the enemy?
		boolean chaseEnemy = false;
		// TODO determine the value of chaseEnemy
		
		if (chaseEnemy) {
			// chase the enemy and continue the battle
		}
		else {
			this.stopBattle();
			this.context.setState(new WanderingState(this.context));
		}
		
	}

}
