package patterns.behavioral.state.impl;

import patterns.behavioral.state.Context;
import patterns.behavioral.state.State;

public class InConversationState extends State {

	public InConversationState(Context context) {
		super(context);
	}

	@Override
	public void handleApproached() {
		// do nothing
	}

	@Override
	public void handleAttacked() {
		// attacked in conversation
		// break the conversation
		this.stopConversation();
		
		// change to InBattleState
		this.context.setState(new InBattleState(this.context));
	}

	@Override
	public void handleConversation() {
		// response to user input
		this.doConversation();
	}

	@Override
	public void handleLeft() {
		// stop conversation
		this.stopConversation();
		
		// switch to InWanderingState
		this.context.setState(new WanderingState(this.context));
	}

	private void doConversation() {
		// implement the conversation logic
	}
	
	private void stopConversation() {
		// stop the conversation logic
	}
	
	
}
