package patterns.behavioral.strategy;

public abstract class BattleContext {

	private BattleStrategy strategy;
	
	protected abstract BattleStrategy determineStrategy();
	
	public void doBattle() {
		// determine strategy
		this.strategy = this.determineStrategy();
		
		// invoke the strategy algorithm
		this.strategy.battle();
		
	}
	
}
