package patterns.behavioral.visitor;

import patterns.behavioral.visitor.impl.BinaryExpression;
import patterns.behavioral.visitor.impl.ConditionalExpression;
import patterns.behavioral.visitor.impl.Constant;
import patterns.behavioral.visitor.impl.Identifier;

/**
 * the context that is needed during interpretation
 */
public abstract class Visitor {

	public abstract Object visitBinaryExpression(BinaryExpression expression);
	
	public abstract Object visitConditionalExpression(ConditionalExpression expression);
	
	public abstract Object visitIdentifier(Identifier identifier);
	
	public abstract Object visitConstant(Constant constant);
	
}
