package patterns.behavioral.visitor.client;

import patterns.behavioral.visitor.Expression;
import patterns.behavioral.visitor.impl.BinaryExpression;
import patterns.behavioral.visitor.impl.ConditionalExpression;
import patterns.behavioral.visitor.impl.Constant;
import patterns.behavioral.visitor.impl.Identifier;
import patterns.behavioral.visitor.impl.InterpreterVisitor;
import patterns.behavioral.visitor.impl.TerminalExpression;

public class InterpreterVisitorClient {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String program = "if (a < 0) then 0 - a else a";
		Expression parseTree = Parser.parse(program);
		InterpreterVisitor visitor = new InterpreterVisitor();
		
		// use a = -5
		System.out.println("setting a = -5");
		visitor.assign("a", new Integer(-5));
		Object result = parseTree.accept(visitor);
		System.out.println("a = -5, (" + program + ") interprets to " + result);
		
		System.out.print("\n\n");
		
		System.out.println("setting a = 3");
		visitor.assign("a", new Integer(3));
		result = parseTree.accept(visitor);
		System.out.println("a = 3, (" + program + ") interprets to " + result);
		
	}
	

}
