package patterns.behavioral.visitor.client;

import patterns.behavioral.visitor.Expression;
import patterns.behavioral.visitor.impl.BinaryExpression;
import patterns.behavioral.visitor.impl.ConditionalExpression;
import patterns.behavioral.visitor.impl.Constant;
import patterns.behavioral.visitor.impl.Identifier;
import patterns.behavioral.visitor.impl.TerminalExpression;

public class Parser {

	public static Expression parse(String program) {
		// TODO parse the program and get the parse tree.
		// for illustrating, we just hard-code the parse tree.
		// refer to builder and composite patter for how to 
		// parse and represent the parse tree
		
		// a
		TerminalExpression identifierA = new Identifier("a");
		// 0
		TerminalExpression constant0 = new Constant(new Integer(0));
		
		// a < 0
		BinaryExpression aLessThan0 = new BinaryExpression(identifierA, "<", constant0);
		
		// 0 - a
		BinaryExpression negativeA = new BinaryExpression(constant0, "-", identifierA);
		
		// if (a < 0) then 0 - a else a
		Expression conditionalExpression = new ConditionalExpression(aLessThan0, negativeA, identifierA);
		
		return conditionalExpression;
	}

	
}
