package patterns.behavioral.visitor.impl;

import patterns.behavioral.visitor.Expression;
import patterns.behavioral.visitor.Visitor;

public class BinaryExpression extends Expression {

	private Expression left;
	private String operator;
	private Expression right;

	public BinaryExpression(Expression left, String operator,
			Expression right) {
		this.left = left;
		this.operator = operator;
		this.right = right;
	}

	
	
	@Override
	public Object accept(Visitor visitor) {

		// let visitor to visit self: calling visitBinaryExpression
		Object result = visitor.visitBinaryExpression(this);
		
		return result;
	}

	
	
	public Expression getLeft() {
		return left;
	}

	public String getOperator() {
		return operator;
	}

	public Expression getRight() {
		return right;
	}

	public String toString() {
		return this.left.toString() + " " + this.operator + " " + this.right.toString();
		
	}
}
