package patterns.behavioral.visitor.impl;

import patterns.behavioral.visitor.Visitor;

public class Constant extends TerminalExpression {

	private Object value;
	
	
	public Constant(Object value) {
		super();
		this.value = value;
	}



	@Override
	public Object accept(Visitor visitor) {

		// let visitor to visit self: calling visitConstant
		Object result = visitor.visitConstant(this);

		return result;
	}

	public Object getValue() {
		return value;
	}

	public String toString() {
		return this.value.toString();
	}
	
}
