package patterns.behavioral.visitor.impl;

import patterns.behavioral.visitor.Visitor;

public class Identifier extends TerminalExpression {

	/**
	 * name of the identifier
	 */
	private String name;
	
	public Identifier(String name) {
		this.name = name;
	}



	@Override
	public Object accept(Visitor visitor) {
		// constants evaluate to their values
		Object result = visitor.visitIdentifier(this);

		// identifier evaluates to its value assignment in the context
		return result;
	}

	public String getName() {
		return name;
	}

	public String toString() {
		return this.name.toString();
		
	}
	
}
