package patterns.creational.abstractfactory.client;

import patterns.creational.abstractfactory.House;
import patterns.creational.abstractfactory.DecoratonFactory;
import patterns.creational.abstractfactory.Fence;

//Client
//uses only the interface defined by AbstractFactory and AbstractProduct
public class Environment {

	private	DecoratonFactory factory;
	private	House house;
	private	Fence fence;
	
	//Constructor
	Environment (DecoratonFactory assignedfactory)
	{
		factory = assignedfactory;
		house = factory.createHouse();
		fence = factory.createFence();
	}
	
	void drawBackground()
	{
		house.showMyself();
	}
	
	void thiefSteal()
	{
		fence.protect();
	}
	
	
	//other methods that use House or Fence interface functions
	//...
	
}
