package patterns.creational.abstractfactory.client;

import patterns.creational.abstractfactory.House;
import patterns.creational.abstractfactory.Fence;
import patterns.creational.abstractfactory.impl.JungleHouse;
import patterns.creational.abstractfactory.impl.JungleFence;
import patterns.creational.abstractfactory.impl.BeachHouse;
import patterns.creational.abstractfactory.impl.BeachFence;


public class FirstAtempEnvironment {
	
	FirstAtempEnvironment (String assignedtype)
	{
		type = assignedtype;
	}
	
	void  drawBackground(){
		if (type.equalsIgnoreCase("jungle")){
			house = new JungleHouse();
			house.showMyself();
		}
		else if (type.equalsIgnoreCase("beach")){
			house = new BeachHouse();
			house.showMyself();
		}
	}
	
	void thiefSteal(){
		if (type.equalsIgnoreCase("jungle")){
			fence = new JungleFence();
			fence.protect();
		}
		else if (type.equalsIgnoreCase("beach")){
			fence = new BeachFence();
			fence.protect();
		}
	}
	
	private String type;
	private Fence fence;
	private House house;
}
