package patterns.creational.abstractfactory.impl;

import patterns.creational.abstractfactory.House;
import patterns.creational.abstractfactory.DecoratonFactory;
import patterns.creational.abstractfactory.Fence;

//Concrete Factory of DecoratonFactory -- BeachFactory
//implements the interface of Abstract Factory
public class BeachFactory implements DecoratonFactory {

	public House createHouse() {
		return new BeachHouse();
	}

	public Fence createFence() {
		return new BeachFence();
	}

}
