package patterns.creational.builder;

//Builder 
//specifies an interface for creating parts of a Product object
public abstract class MazeBuilder {
	protected Maze maze;
	
	public abstract void buildRoom();
	public abstract void buildWall();
	public abstract void buildDoor();
	
	public Maze getMaze(){
		return maze;
	}
	
	public MazeBuilder(){
		initMaze();
	}
	
	private void initMaze(){
		maze = new Maze();
	}
}
