package patterns.creational.builder.client;

import patterns.creational.builder.Maze;
import patterns.creational.builder.MazeBuilder;
import patterns.creational.builder.impl.FireMazeBuilder;
import patterns.creational.builder.impl.IceMazeBuilder;

public class PerformBuilder {

	/**
	 * @param args[0] maze type
	 */
	public static void main(String[] args) {
		MazeBuildDirector director;
		MazeBuilder builder = null;
		director = new MazeBuildDirector();
		if (args[0].equalsIgnoreCase("fire")){
			builder = new FireMazeBuilder();
		}
		else if (args[0].equalsIgnoreCase("ice")){
			builder = new IceMazeBuilder();
		}
		
		if (builder != null){
			director.setBuilder(builder);
			director.constructMaze();
			Maze maze = director.getMaze();
		
			maze.show();
		}
		
	}

}
