package patterns.creational.factorymethod.client;

import patterns.creational.factorymethod.House;
import patterns.creational.factorymethod.HouseCreator;
import patterns.creational.factorymethod.impl.JungleHouseCreator;
import patterns.creational.factorymethod.impl.BeachHouseCreator;

public class PerformFactoryMethod {

	/**
	 * @param args[0] weapon type
	 */
	public static void main(String[] args) {
		HouseCreator creator = null;
		House house = null;
		
		//choose the creator according to input
		if (args[0].equalsIgnoreCase("jungle_house")){
			creator = new JungleHouseCreator();			
		}
		else if (args[0].equalsIgnoreCase("beach_house")){
			creator = new BeachHouseCreator();	
		}
		
		//create a house
		if(creator != null)
			house = creator.createHouse();
		
		//somewhere in the code
		if (house != null){
			int thief;
			house.showMyself();
			
			thief = 10;
			house.protect(thief);
		}
		
		
		

	}

}
