package patterns.creational.prototype.impl;

import patterns.creational.prototype.Map;
import java.util.ArrayList;

//Concrete Prototype
//implements an operator for cloning itself.
public class Level2Map extends Map {
	
	public Level2Map (ArrayList<String> assignedconfig){
		configs = assignedconfig;
	}
	
	@Override
	public void draw(){
		System.out.println("drawing level 2 map");
		java.util.Iterator<String> iterator = configs.iterator();
		while (iterator.hasNext()){
			System.out.println("drawing "+ iterator.next());				
		}
	}
	

	public Object clone() throws CloneNotSupportedException {
		Level2Map newcopy = (Level2Map)super.clone();
		
		if (configs != null){
			newcopy.configs = (ArrayList<String>) configs.clone();
		}		
		return newcopy;
	}
	
	
}

