package patterns.creational.prototype.impl;

import java.util.ArrayList;

import patterns.creational.prototype.Map;

//Concrete Prototype
//implements an operator for cloning itself.
public class Level3Map extends Map {
	
	public Level3Map (ArrayList<String> assignedconfig){
		configs = assignedconfig;
	}
	
	@Override
	public void draw(){
		System.out.println("drawing level 3 map");
		java.util.Iterator<String> iterator = configs.iterator();
		while (iterator.hasNext()){
			System.out.println("drawing "+ iterator.next());				
		}
	}
	

	public Object clone() throws CloneNotSupportedException {
		Level3Map newcopy = (Level3Map)super.clone();
		
		if (configs != null){
			newcopy.configs = (ArrayList<String>) configs.clone();
		}	
		return newcopy;
	}
	
	
}
