package patterns.creational.singleton;

//Singleton
//defines a static member function that lets clients access its unique instance
public class Clock {
	private Clock() {};
	private static Clock instance;
	
	public static Clock getInstance(){
		if (instance == null)
			instance = new Clock();
		
		return instance;
	}
	
	public void getCurrentTime(){
		System.out.println("It is 11:50am!");
	}	
}
