package patterns.structural.adapter;

public class GraphicController {

	MapRender render;
	
	float x1,y1,x2,y2,x3,y3;
	
	
	public GraphicController(){
		
		render = new InHouseEngine();
	}
	
	public void loadData(){
		x1 = y1 = 0F;
		x2 = y2 = 1F;
		x3 = y3 = 2F;
	}
	
	public void drawMap(){
		
		render.drawTriangle(x1,y1, x2, y2,  x3, y3);
	
	}
	
	public void setRender(MapRender render){
		
		this.render = render;
	}
	
	
	public static void main(String[] args){
		
		GraphicController controller = new GraphicController();
		
		System.out.println("Use InHouse Engine\n");
		controller.loadData();
		controller.drawMap();
			
		System.out.println("\nUse ThirdParty Engine With Object Adapter\n");
		controller.setRender(new ThirdPartyRenderAdapterObject());
		controller.drawMap();
		
		System.out.println("\nUse ThirdParty Engine With Class Adapter\n");
		controller.setRender(new ThirdPartyRenderAdapterClass());
		controller.drawMap();
		
	}
	
}
