package patterns.structural.bridge;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class FileStore extends PersistentStoreImpl {

	@Override
	public UserProfile retrieveProfile(String username) {
		
		UserProfile result = null;
		
		String filename = username+".ser";
		File file = new File(filename);
		
		if(!file.exists()) 
			System.out.println("File not found:"+filename);
		
		try {
			 
			System.out.println("User profile retrieved. Filename: "+filename);
			
			ObjectInputStream objInputStream = 
			     new ObjectInputStream(new FileInputStream(file));
			
			result = (UserProfile) objInputStream.readObject();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} 
		   
		return result;
	}

	@Override
	public void saveProfile(UserProfile profile) {
	
		String filename = profile.getName()+".ser";
		File file = new File(filename);
		
		try {
		
			ObjectOutputStream objOutputStream = new ObjectOutputStream(new FileOutputStream(file));
			objOutputStream.writeObject(profile);
			objOutputStream.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("User profile saved. Filename: "+filename);
		
	}

}
