package patterns.structural.bridge;

public class MemberManagementStore extends PersistentStore {

	private static MemberManagementStore instance = null;
	
	
	public void createMember(String username){
	
		UserProfile profile = new UserProfile(username);
		saveProfile(profile);
	}

	public void updateMemberInfo(String username,int level){
		
		UserProfile profile = retrieveProfile(username);
		profile.setLevel(level);
		saveProfile(profile);
	}
	
	
	public static void main(String[] args){
	
		MemberManagementStore store = new MemberManagementStore();
		
		store.createMember("Jeffrey");
		
		store.updateMemberInfo("Jeffrey", 50);
		
	}

	public static MemberManagementStore getInstance() {
		
		if(instance == null)
			instance = new MemberManagementStore();
		
		return instance;
	}
}

