package patterns.structural.bridge;

public abstract class PersistentStoreImpl  {

	
	public static PersistentStoreImpl getPersistentStore(String type){
		
		PersistentStoreImpl impl = null;

		if(type.equalsIgnoreCase("file"))
			impl = new FileStore();
		else if(type.equalsIgnoreCase("db"))
			impl = new DBStore();
		
		return impl;
	}
	
	public abstract UserProfile retrieveProfile(String username);

	public abstract void saveProfile(UserProfile profile);
	
}
