package patterns.structural.composite;

import java.util.Enumeration;
import java.util.Vector;

public class SubTeam extends Team {
    
	public SubTeam(String name) {
		super(name);
	}

	Vector<Team> subTeams = new Vector<Team>();
	
	public void addTeam(Team t) {
		
		subTeams.add(t);
		t.setParent(this);

	}

	public Team getTeam(int index) {
		return subTeams.get(index);

	}

	public void removeTeam(Team t) {
		subTeams.remove(t);
		t.setParent(null);
	}

	@Override
	public void broadcast(String message) {
		
		Enumeration subteams = subTeams.elements();
		
		while(subteams.hasMoreElements()){
			Team subteam = (Team)subteams.nextElement();
			subteam.broadcast(message);
		}
		
	}
	
	
	public void traversal(Visitor visitor){
		
		visitor.visit(this);
		
		Enumeration subteams = subTeams.elements();
		
		while(subteams.hasMoreElements()){
			Team subteam = (Team)subteams.nextElement();
			subteam.traversal(visitor);
		}
		
	}
	

}
