package patterns.structural.composite;

public abstract class Team {
	
	String name = null;
	Team parent = null;
	
	public Team(String name){
		
		this.name = name;
	}
	
	
	
	public abstract void addTeam(Team t);
	public abstract void removeTeam(Team t);
	public abstract Team getTeam(int index);	
	public abstract void broadcast(String message);
	
	
	public abstract void traversal(Visitor visitor);
	
	public void broacastParent(){
		
	
		
	}
	
	public void broadcastToAll(String message){
		getRoot().broadcast(name+" said:" +message);
	}
	
	public void setParent(Team team){
		
		this.parent = team;
	}
	
	public Team getRoot(){
		
		if(parent == null){
			return this;
		}else{
			
			return parent.getRoot();
		}
		
	}
	
}
