package patterns.structural.composite;

public class TeamController {
	
	private Team commander = null;
	
	public TeamController(){
	
		commander = new SubTeam("Commander");
		
	}
	
	public void broadcastMessage(String message){
		
		commander.broadcastToAll(message);
	}
	

	public static void main(String[] args){
		
		// construct the team hierarchy
		
		
		Team subteam1 = new SubTeam("team1");
		Team Jeffrey = new TeamMember("Jeffrey");
		subteam1.addTeam(Jeffrey);
		
		Team subteam2 = new SubTeam("team2");
		subteam2.addTeam(new TeamMember("Clement"));
		subteam2.addTeam(new TeamMember("Jim"));
		
		Team subteam3 = new SubTeam("team2.1");
		subteam3.addTeam(new TeamMember("Bob"));
		subteam2.addTeam(subteam3);
		
		Team commander = new SubTeam("Commander");
		commander.addTeam(subteam1);
		commander.addTeam(subteam2);
		
		
		commander.broadcast("Commander broadcast");
		Jeffrey.broadcastToAll("Hello team");
		subteam2.broadcast("Subteam2 attention");
		commander.removeTeam(subteam1);
		commander.broadcast("subteam 1 has been removed");
		
		
		System.out.println("\n\n Running Echo Visitor... \n");
		
		commander.traversal(new EchoVisitor());
	}

	public void buildTeam() {
		
		Team subteam1 = new SubTeam("team1");
		Team Jeffrey = new TeamMember("Jeffrey");
		subteam1.addTeam(Jeffrey);
		
		Team subteam2 = new SubTeam("team2");
		subteam2.addTeam(new TeamMember("Clement"));
		subteam2.addTeam(new TeamMember("Jim"));
		
		Team subteam3 = new SubTeam("team3");
		subteam3.addTeam(new TeamMember("Bob"));
		subteam2.addTeam(subteam3);
		
		commander.addTeam(subteam1);
		commander.addTeam(subteam2);
		
		
		
	}
}
