package patterns.structural.decorator;

import java.util.Hashtable;

public class CacheDecorator extends AccessControllerDecorator {

	
	Hashtable<String, String> cache = new Hashtable<String, String>();
	
	
	public CacheDecorator(AccessController controller) {
		super(controller);
	}
	
	@Override
	public boolean authenticate(String username, String password) {

		
		boolean result = false;
		
		if(cache.containsKey(username)){
			
			String cachedPassword = (String)cache.get(username);
			if(password.equalsIgnoreCase(cachedPassword)){
				result = true;
				System.out.println("[Cache] "+username+" hits!");
			}
		}else{
			
			result = originalController.authenticate(username,password);
			
			if(result){
				
				cache.put(username, password);
			}
		}
		
		return result;
	}

	
	
}
