package patterns.structural.decorator;

import java.util.Hashtable;

public class StatisticDecorator extends AccessControllerDecorator {

	Hashtable<String, Integer> counter = new Hashtable<String, Integer>();
	
	
	public StatisticDecorator(AccessController controller) {
		super(controller);

	}

	@Override
	public boolean authenticate(String username, String password) {

		int currentCount = 0;
		
		if(counter.containsKey(username)){
			
			currentCount = ((Integer)counter.get(username)).intValue();		
		}
		
		currentCount++;
		
		
		counter.put(username, new Integer(currentCount));
		
		System.out.println("[Statistic] "+username+"'s "+currentCount+" th login");
		
		return originalController.authenticate(username, password);
	}

}
