package patterns.structural.flyweight;

import java.util.Random;

public abstract class Character {
	
	
	public static final String CHAR_CHILDREN = "children";
	public static final String CHAR_SOLDIER = "soldier";
	
	int steps;
	
	public void randomWalk(CharacterState state) {
		
		int origX = state.getCurrentX();
		int origY = state.getCurrentY();
		
		
		int newX = move(origX,steps);
		int newY = move(origY,steps);
		
		state.setCurrentX(newX);
		state.setCurrentY(newY);
		
		System.out.println("["+state.getName()+"]\t"+
				           "I am moving from ("+origX+","+origY+") to ("+newX+","+newY+")");
		
	}
	
	protected int move(int orig, int step){
				
		Random generator = new Random();
		return generator.nextInt(5) * step; 
		
	}
	
}
