package patterns.structural.flyweight;

import java.util.*;

public class CharacterController extends Thread{

	
	Vector<CharacterState> allCharacters = new Vector<CharacterState>();
	
	public CharacterController(int characters){
		
		allCharacters.add(new CharacterState("Jeffrey",Character.CHAR_SOLDIER));
		allCharacters.add(new CharacterState("Clement",Character.CHAR_CHILDREN));
		allCharacters.add(new CharacterState("Jim Yu",Character.CHAR_CHILDREN));

	}
	
	public void run(){
		
		while(true){
		
			randomWalk();
			
			try {
				sleep(3000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}		
		
	}	
	
	
	private void randomWalk(){
		
		for(Enumeration e = allCharacters.elements();e.hasMoreElements();){
			CharacterState state = (CharacterState)e.nextElement();
			Character c= CharacterFactory.getCharacter(state.getType());
			c.randomWalk(state);
		}
	}
	
	
	public static void main(String[] args){
		
		
		CharacterController controller = new CharacterController(5);
		controller.start();
		
	}
}
