package patterns.structural.flyweight;

import java.util.Hashtable;

public class CharacterFactory {

	
	
	
	static Hashtable<String, Character> pool = new Hashtable<String, Character>();
	
	public static Character getCharacter(String type) {
		
		Character result = null;
		
		if(pool.containsKey(type)){
			
			result = (Character)pool.get(type);
			
		}else{
			
			result = CreateCharacter(type); 
			pool.put(type, result);			
		}
		
			
		return result;
	}

	private static Character CreateCharacter(String type) {
		
		if(type.equalsIgnoreCase("children")){
			
			return new Children();

		}else if(type.equalsIgnoreCase("soldier")){
			
			return new Soldier();
		}
		
		return null;
	}
	
}
